<?php
/* funkcia na vykreslenie error obrzku
parameter - retazec, ktor sa m vypsa ako ERROR */
function ErrorImage($string)
{
    header ("Content-type: image/png");
    $im = imagecreate (300, 50);
    $background_color = imagecolorallocate ($im, 200, 200, 200);
    $text_color = imagecolorallocate ($im, 233, 14, 91);
    imagestring ($im, 5, 5, 5,"ERROR: ".$string, $text_color);
    imagepng ($im);
    exit();
}

/* ak subor existuje - zskanie informci o obrzku
$size[0] - rka
$size[1] - vka
$size[2] - formt */
if(file_exists($_GET["filename"]))
    $size=getimagesize($_GET["filename"]);

/* ak subor neexistuje - zobrazenie error obrazku */
else
    ErrorImage("Sbor neexistuje");

/* ak zadan rka je menia ako 1px, alebo nie je slo, tak sa vykresl error obrzok
to ist plat aj pre vsku */
if($_GET["width"]<1)
    ErrorImage("Nekorektna sirka nahladu");
if($_GET["height"]<1)
    ErrorImage("Nekorektna vyska nahladu");

/* pridelenie hlaviky */
switch($size[2])
{
    case 1:
        $type="gif";
        header("Content-type: image/png");
        break;
    case 2:
        $type="jpeg";
        header("Content-type: image/jpeg");
        break;
    case 3:
        $type="png";
        header("Content-type: image/png");
        break;

/* ak je to in formt obrzku alebo to nie je obrzok, vykreslenie error obrzku */
    default:
        ErrorImage("Nekorektny typ suboru");
}

/* vpoet novej rky a vky */
$scale_width=$_GET["width"]/$size[0];
$scale_height=$_GET["height"]/$size[1];
$scale=($scale_width <= $scale_height ? $scale_width : $scale_height);
$new_width=ceil($scale*$size[0]);
$new_height=ceil($scale*$size[1]);

/* vytvorenie cieovho a zdrojovho obrzku */
    $im = imagecreatetruecolor($new_width,$new_height);
switch($type)
{
    case "gif":
        $res_im=imagecreatefromgif($_GET["filename"]);
        break;
    case "jpeg":
        $res_im=imagecreatefromjpeg($_GET["filename"]);
        break;
    case "png":
        $res_im=imagecreatefrompng($_GET["filename"]);
        break;
}

/* koprovanie oblasti do cieovho obzku */
imagecopyresampled($im,$res_im,0,0,0,0,$new_width+1,$new_height+1,$size[0],$size[1]);

/* zruenie zdrojovho obrzku */
imagedestroy($res_im);

/* vstup nhadu do browsera */
switch($type)
{
    case "jpeg":
        imagejpeg($im);
        break;
    case "gif":
    case "png":
        imagepng($im);
        break;
}
?>
